/* 
**  utility.c
*/ 

#include "mod_mp3.h"

MP3_EXPORT(const char *) make_basename(request_rec *r) {
	return ap_pstrcat(r->pool, "http://", r->server->server_hostname, ":", (ap_psprintf(r->pool, "%d", r->server->port)), r->uri, NULL);
}

MP3_EXPORT(array_header *) get_songs(pool *p, table * t) {
	array_header *songs  = ap_make_array (p, 5, sizeof (char *));
	array_header *hdrs_arr;
	table_entry *elts;
	int i;

	if (t == NULL)
		return NULL;

	hdrs_arr = ap_table_elts(t);
	elts = (table_entry *) hdrs_arr->elts;

	for (i = 0; i < hdrs_arr->nelts; ++i) {
		if(!strcasecmp("song", elts[i].key)) {
			*(char **) ap_push_array (songs) = ap_pstrdup (p, elts[i].val );
		}
	}

	if(songs->nelts) {
		return songs;
	} else {
		return NULL;
	}
}

MP3_EXPORT(table *) parse_args(request_rec *r) {
	const char *data = NULL;
	const char *keypair = NULL;
	const char *key = NULL;
	const char *value = NULL;
	table *arguments;
	int size=0;
	int x=0;

	if(r->args) {
		arguments = ap_make_table(r->pool, 4);
		data = ap_pstrdup(r->pool, r->args);
		while(*data && (keypair = ap_getword(r->pool, &data, '&'))){
			if((x = ap_ind(keypair, '=')) != -1) {
				size = strlen(keypair);
				value = (keypair) + (x+1);	
				key = ap_pstrndup(r->pool, keypair, x);
				ap_table_add(arguments, key, value);
			} else {
				ap_table_add(arguments,keypair, "");
			}
		}
	} else {
		return NULL;
	}

	return arguments;
}

MP3_EXPORT(void) table_list(char *string, table * t) {
	array_header *hdrs_arr;
	table_entry *elts;
	int i;

	if (t == NULL)
		return;
	if (string == NULL)
		return;

	hdrs_arr = ap_table_elts(t);
	elts = (table_entry *) hdrs_arr->elts;

	for (i = 0; i < hdrs_arr->nelts; ++i) {
		printf("%s:Key %s:%s:\n", string, elts[i].key, elts[i].val);
	}
}
